Index: issm/trunk/src/m/solve/marshall.m
===================================================================
--- issm/trunk/src/m/solve/marshall.m	(revision 25994)
+++ issm/trunk/src/m/solve/marshall.m	(revision 26744)
@@ -44,9 +44,9 @@
 st=fclose(fid);
 
-% Uncomment the following to make a copy of the binary input file for debugging 
-% purposes (can be fed into scripts/ReadBin.py).
-% copyfile([md.miscellaneous.name '.bin'], [md.miscellaneous.name '.m.bin'])
-
 if st==-1,
 	error(['marshall error message: could not close file ' [md.miscellaneous.name '.bin']]);
 end
+
+% Uncomment the following to make a copy of the binary input file for debugging 
+% purposes (can be fed into scripts/BinRead.py).
+% copyfile([md.miscellaneous.name '.bin'], [md.miscellaneous.name '.m.bin'])
Index: issm/trunk/src/m/solve/marshall.py
===================================================================
--- issm/trunk/src/m/solve/marshall.py	(revision 25994)
+++ issm/trunk/src/m/solve/marshall.py	(revision 26744)
@@ -17,5 +17,5 @@
         print("marshalling file {}.bin".format(md.miscellaneous.name))
 
-    #open file for binary writing
+    # Open file for binary writing
     try:
         fid = open(md.miscellaneous.name + '.bin', 'wb')
@@ -26,15 +26,15 @@
     fields.sort() # sort fields so that comparison of binary files is easier
     for field in fields:
-        #Some properties do not need to be marshalled
+        # Some properties do not need to be marshalled
         if field in ['results', 'radaroverlay', 'toolkits', 'cluster', 'private']:
             continue
 
-        #Check that current field is an object
+        # Check that current field is an object
         if not hasattr(getattr(md, field), 'marshall'):
             raise TypeError("field '{}' is not an object.".format(field))
 
-        #Marshall current object
-        #print "marshalling %s ..." % field #Uncomment for debugging
-        exec("md.{}.marshall('md.{}', md, fid)".format(field, field))
+        # Marshall current object
+        #print('marshalling {} ...'.format(field) # Uncomment for debugging
+        exec('md.{}.marshall(\'md.{}\', md, fid)'.format(field, field))
 
     #Last, write "md.EOF" to make sure that the binary file is not corrupt
@@ -45,9 +45,9 @@
         fid.close()
 
-        # Uncomment the following to make a copy of the binary input file for 
-        # debugging purposes (can be fed into scripts/ReadBin.py).
-        # copy_cmd = "cp {}.bin {}.py.bin".format(md.miscellaneous.name, md.miscellaneous.name)
-        # subprocess.call(copy_cmd, shell=True)
+    except IOError as e:
+        print('marshall error message: could not close file \'{}.bin\' due to:'.format(md.miscellaneous.name), e)
 
-    except IOError as e:
-        print("marshall error message: could not close file '{}.bin' due to:".format(md.miscellaneous.name), e)
+    # Uncomment the following to make a copy of the binary input file for 
+    # debugging purposes (can be fed into scripts/BinRead.py).
+    # copy_cmd = 'cp {}.bin {}.py.bin'.format(md.miscellaneous.name, md.miscellaneous.name)
+    # subprocess.call(copy_cmd, shell=True)
Index: issm/trunk/src/m/solve/parseresultsfromdisk.m
===================================================================
--- issm/trunk/src/m/solve/parseresultsfromdisk.m	(revision 25994)
+++ issm/trunk/src/m/solve/parseresultsfromdisk.m	(revision 26744)
@@ -225,4 +225,20 @@
 	elseif strcmp(fieldname,'Vel'),
 		field = field*yts;
+	elseif strcmp(fieldname,'VxShear'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VyShear'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VxBase'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VyBase'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VxSurface'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VySurface'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VxAverage'),
+		field = field*yts;
+	elseif strcmp(fieldname,'VyAverage'),
+		field = field*yts;
 	elseif strcmp(fieldname,'BasalforcingsGroundediceMeltingRate'),
 		field = field*yts;
@@ -251,4 +267,6 @@
 	elseif strcmp(fieldname,'SmbPrecipitation'),
 		field = field*yts;
+	elseif strcmp(fieldname,'SmbRain'),
+		field = field*yts;
 	elseif strcmp(fieldname,'SmbRunoff'),
 		field = field*yts;
@@ -266,4 +284,6 @@
 		field = field*yts;
 	elseif strcmp(fieldname,'SmbMAdd'),
+		field = field*yts;
+	elseif strcmp(fieldname,'SmbWAdd'),
 		field = field*yts;
 	elseif strcmp(fieldname,'CalvingCalvingrate'),
Index: issm/trunk/src/m/solve/parseresultsfromdisk.py
===================================================================
--- issm/trunk/src/m/solve/parseresultsfromdisk.py	(revision 25994)
+++ issm/trunk/src/m/solve/parseresultsfromdisk.py	(revision 26744)
@@ -80,5 +80,5 @@
         fid = open(filename, 'rb')
     except IOError as e:
-        raise IOError("parseresultsfromdisk error message: could not open {} for binary reading".format(filename))
+        raise IOError('parseresultsfromdisk error message: could not open {} for binary reading'.format(filename))
 
     # Collect all results in a list
@@ -127,9 +127,9 @@
     """
 
-    #read field
+    # Read field
     try:
         length = struct.unpack('i', fid.read(struct.calcsize('i')))[0]
         fieldname = struct.unpack('{}s'.format(length), fid.read(length))[0][:-1]
-        fieldname = fieldname.decode()  #strings are binaries when stored so need to be converted back
+        fieldname = fieldname.decode() # strings are binaries when stored so need to be converted back
         time = struct.unpack('d', fid.read(struct.calcsize('d')))[0]
         step = struct.unpack('i', fid.read(struct.calcsize('i')))[0]
@@ -145,5 +145,5 @@
         elif datatype == 3:
             N = struct.unpack('i', fid.read(struct.calcsize('i')))[0]
-    #field = transpose(fread(fid, [N M], 'double'))
+            #field = transpose(fread(fid, [N M], 'double'))
             field = np.zeros(shape=(M, N), dtype=float)
             for i in range(M):
@@ -152,5 +152,5 @@
         elif datatype == 4:
             N = struct.unpack('i', fid.read(struct.calcsize('i')))[0]
-    # field = transpose(fread(fid, [N M], 'int'))
+            #field = transpose(fread(fid, [N M], 'int'))
             field = np.zeros(shape=(M, N), dtype=int)
             for i in range(M):
@@ -158,7 +158,7 @@
 
         else:
-            raise TypeError("cannot read data of datatype {}".format(datatype))
-
-        #Process units here FIXME: this should not be done here!
+            raise TypeError('cannot read data of datatype {}'.format(datatype))
+
+        # Process units here FIXME: this should not be done here!
         yts = md.constants.yts
         if fieldname == 'BalancethicknessThickeningRate':
@@ -176,4 +176,20 @@
         elif fieldname == 'Vel':
             field = field * yts
+        elif fieldname == 'VxShear':
+            field = field * yts
+        elif fieldname == 'VyShear':
+            field = field * yts
+        elif fieldname == 'VxBase':
+            field = field * yts
+        elif fieldname == 'VyBase':
+            field = field * yts
+        elif fieldname == 'VxSurface':
+            field = field * yts
+        elif fieldname == 'VySurface':
+            field = field * yts
+        elif fieldname == 'VxAverage':
+            field = field * yts
+        elif fieldname == 'VyAverage':
+            field = field * yts
         elif fieldname == 'BasalforcingsGroundediceMeltingRate':
             field = field * yts
@@ -181,25 +197,27 @@
             field = field * yts
         elif fieldname == 'TotalFloatingBmb':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'TotalFloatingBmbScaled':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'TotalGroundedBmb':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'TotalGroundedBmbScaled':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'TotalSmb':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'TotalSmbScaled':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'GroundinglineMassFlux':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'IcefrontMassFlux':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'IcefrontMassFluxLevelset':
-            field = field / 10.**12 * yts  #(GigaTon/year)
+            field = field / pow(10.0, 12) * yts # (GigaTon/year)
         elif fieldname == 'SmbMassBalance':
             field = field * yts
         elif fieldname == 'SmbPrecipitation':
             field = field * yts
+        elif fieldname == 'SmbRain':
+            field = field * yts
         elif fieldname == 'SmbRunoff':
             field = field * yts
@@ -217,4 +235,6 @@
             field = field * yts
         elif fieldname == 'SmbMAdd':
+            field = field * yts
+        elif fieldname == 'SmbWAdd':
             field = field * yts
         elif fieldname == 'CalvingCalvingrate':
Index: issm/trunk/src/m/solve/solve.js
===================================================================
--- issm/trunk/src/m/solve/solve.js	(revision 25994)
+++ issm/trunk/src/m/solve/solve.js	(revision 26744)
@@ -1,90 +1,116 @@
-function solve(md, solutionstring) {//{{{
-/**
- * SOLVE - apply solution sequence for this model
- *
- *	Usage:
- *		solve(md, solutionstring, varargin);
- *		where varargin is a list of paired arguments of string OR enums
- *
- *	solution types available comprise:
- *		- 'Stressbalance'		or 'sb'
- *		- 'Masstransport'		or 'mt'
- *		- 'Thermal'				or 'th'
- *		- 'Steadystate'			or 'ss'
- *		- 'Transient'			or 'tr'
- *		- 'Balancethickness'	or 'mc'
- *		- 'Balancevelocity'		or 'bv'
- *		- 'BedSlope'			or 'bsl'
- *		- 'SurfaceSlope'		or 'ssl'
- *		- 'Hydrology'			or 'hy'
- *		- 'DamageEvolution'		or 'da'
- *		- 'Gia'					or 'gia'
- *		- 'Sealevelrise'		or 'slr'
- *
- *	extra options:
- *		- loadonly    		: do not solve, only load results
- *		- runtimename 		: true or false (default is true), makes name unique
- *		- checkconsistency 	: 'yes' or 'no' (default is 'yes'), ensures checks on consistency of model
- *		- restart			: directory name (relative to the execution directory) where the restart file is located
- *		- successCallback	: callback function to be called on success
- *		- errorCallback		: callback function to be called on error
- *
- *	reporting:
- *		With no optional arguments for reporting, progress and error reporting is written to the DOM element with ID 'solve-button'.
- *		- solveButtonId		: overrides default solve button ID
- *		- callout			: Callout to report progress/errors to; overrides reporting to solve button
- *		- withProgressBar	: reports progress of certain solution stages with a progress bar; will not display if a Callout has not been provided
- *
- *	Examples:
- *		md = solve(md, 'Stressbalance');
- *		md = solve(md, 'sb');
- */
-	if (typeof solutionstring !== 'string') {
-		throw Error(sprintf("%s\n", "ISSM's solve function only accepts strings for solution sequences. Type help solve to get a list of supported solutions."));
-	}
-
-	//recover and process solve options
-	let solutionStringLowerCase = solutionstring.toLowerCase();
-	
-	if ((solutionStringLowerCase === 'sb') || (solutionStringLowerCase === 'stressbalance')) {
+async function solve(md, solutionstring, ...varargin) { //{{{
+/*
+SOLVE - apply solution sequence for this model
+
+Usage:
+	solve(md, solutionstring[, ...]);
+
+where varargin is a list of paired arguments of string OR enums
+
+Solution types available comprise:
+- 'Stressbalance'			or 'sb'
+- 'Masstransport'			or 'mt'
+- 'Oceantransport'			or 'oceant'
+- 'Thermal'					or 'th'
+- 'Steadystate'				or 'ss'
+- 'Transient'				or 'tr'
+- 'Balancethickness'		or 'mc'
+- 'BalancethicknessSoft'	or 'mcsoft'
+- 'Balancevelocity'			or 'bv'
+- 'BedSlope'				or 'bsl'
+- 'SurfaceSlope'			or 'ssl'
+- 'Hydrology'				or 'hy'
+- 'DamageEvolution'			or 'da'
+- 'Gia'						or 'gia'
+- 'Love'					or 'lv'
+- 'Esa'						or 'esa'
+- 'Sampling'				or 'smp'
+- 'Gmsh'
+
+Extra options (these all need to be passed in via the third parameter, which is 
+a rest parameter):
+- loadonly    		: do not solve, only load results
+- runtimename 		: true or false (default is true); makes name unique
+- checkconsistency 	: true or false (default is true); checks consistency of model
+- restart			: directory name (relative to the execution directory) where the restart file is located
+
+Examples:
+	md = solve(md, 'Stressbalance');
+	md = solve(md, 'sb');
+	
+NOTE:
+- We do not strictly need to return md as objects are passed by reference in 
+JavaScript, but we do so to mirror MATLAB and Python APIs.
+
+TODO:
+- Refactor UI reporting structure so we do not have to check if it is defined
+*/	
+ 
+/*
+	// Check that md exists and that it is a model
+ 	if (md === null || md === undefined || md.constructor.name !== 'model') {
+ 		throw new Error('md needs to be an instance of the model class');
+ 	}
+*/
+	
+	if (typeof(solutionstring) !== 'string') {
+		throw new Error('ISSM\'s solve function only accepts strings for solution sequences. Type help solve to get a list of supported solutions.');
+	}
+
+	// Recover and process solve options
+	if (vesl.strings.strcmpi(solutionstring, 'sb') || vesl.strings.strcmpi(solutionstring, 'Stressbalance')) {
 		solutionstring = 'StressbalanceSolution';
-	} else if ((solutionStringLowerCase === 'mt') || (solutionStringLowerCase === 'masstransport')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'mt') || vesl.strings.strcmpi(solutionstring, 'Masstransport')) {
 		solutionstring = 'MasstransportSolution';	
-	} else if ((solutionStringLowerCase === 'th') || (solutionStringLowerCase === 'thermal')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'oceant') || vesl.strings.strcmpi(solutionstring, 'Oceantransport')) {
+		solutionstring = 'OceantransportSolution';	
+	} else if (vesl.strings.strcmpi(solutionstring, 'th') || vesl.strings.strcmpi(solutionstring, 'Thermal')) {
 		solutionstring = 'ThermalSolution';
-	} else if ((solutionStringLowerCase === 'st') || (solutionStringLowerCase === 'steadystate')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'st') || vesl.strings.strcmpi(solutionstring, 'Steadystate')) {
 		solutionstring = 'SteadystateSolution';
-	} else if ((solutionStringLowerCase === 'tr') || (solutionStringLowerCase === 'transient')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'tr') || vesl.strings.strcmpi(solutionstring, 'Transient')) {
 		solutionstring = 'TransientSolution';
-	} else if ((solutionStringLowerCase === 'mc') || (solutionStringLowerCase === 'balancethickness')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'mc') || vesl.strings.strcmpi(solutionstring, 'Balancethickness')) {
 		solutionstring = 'BalancethicknessSolution';
-	} else if ((solutionStringLowerCase === 'bv') || (solutionStringLowerCase === 'balancevelocity')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'mcsoft') || vesl.strings.strcmpi(solutionstring, 'BalancethicknessSoft')) {
+		solutionstring = 'BalancethicknessSoftSolution';
+	} else if (vesl.strings.strcmpi(solutionstring, 'bv') || vesl.strings.strcmpi(solutionstring, 'Balancevelocity')) {
 		solutionstring = 'BalancevelocitySolution';
-	} else if ((solutionStringLowerCase === 'bsl') || (solutionStringLowerCase === 'bedslope')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'bsl') || vesl.strings.strcmpi(solutionstring, 'BedSlope')) {
 		solutionstring = 'BedSlopeSolution';
-	} else if ((solutionStringLowerCase === 'ssl') || (solutionStringLowerCase === 'surfaceslope')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'ssl') || vesl.strings.strcmpi(solutionstring, 'SurfaceSlope')) {
 		solutionstring = 'SurfaceSlopeSolution';
-	} else if ((solutionStringLowerCase === 'hy') || (solutionStringLowerCase === 'hydrology')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'hy') || vesl.strings.strcmpi(solutionstring, 'Hydrology')) {
 		solutionstring = 'HydrologySolution';
-	} else if ((solutionStringLowerCase === 'da') || (solutionStringLowerCase === 'damageevolution')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'da') || vesl.strings.strcmpi(solutionstring, 'DamageEvolution')) {
 		solutionstring = 'DamageEvolutionSolution';
-	} else if ((solutionStringLowerCase === 'gia') || (solutionStringLowerCase === 'gia')) {
+	} else if (vesl.strings.strcmpi(solutionstring, 'gia') || vesl.strings.strcmpi(solutionstring, 'Gia')) {
 		solutionstring = 'GiaSolution';
-	} else if ((solutionStringLowerCase === 'slr') || (solutionStringLowerCase === 'sealevelrise')) {
-		solutionstring = 'SealevelriseSolution';
+	} else if (vesl.strings.strcmpi(solutionstring, 'lv') || vesl.strings.strcmpi(solutionstring, 'Love')) {
+		solutionstring = 'LoveSolution';
+	} else if (vesl.strings.strcmpi(solutionstring, 'Esa')) {
+		solutionstring = 'EsaSolution';
+	} else if (vesl.strings.strcmpi(solutionstring, 'smp') || vesl.strings.strcmpi(solutionstring, 'Sampling')) {
+		solutionstring = 'SamplingSolution';
+	} else if (vesl.strings.strcmpi(solutionstring, 'gmsh')) {
+		solutionstring = 'GmshSolution';
+	} else if (vesl.strings.strcmpi(solutionstring, 'gmt')) {
+		solutionstring = 'GmtSolution';
 	} else {
-		throw Error(sprintf("%s%s%s\n",'solutionstring ',solutionstring,' not supported!'));
-	}
-	
-	// Process options
-	let args 	= Array.prototype.slice.call(arguments);
-	let options = new pairoptions(args.slice(2, args.length));
-	options.addfield('solutionstring', solutionstring);
-
-	// recover some fields
+		throw new Error('solutionstring ' + solutionstring + ' not supported!');
+	}
+	let options = new pairoptions(varargin, 'solutionstring', solutionstring);
+	
+	// Recover some fields
 	md.priv.solution 	= solutionstring;
-	cluster 			= md.cluster;
-
-	//check model consistency
+	let cluster 		= md.cluster;
+	
+	// NOTE: Batch scripts are not currently implemented
+	let batch = 0; 
+	if (options.getfieldvalue('batch', 'no') === 'yes') {
+		batch = 1;
+	}
+	
+	// Check model consistency
 	if (options.getfieldvalue('checkconsistency', 'yes') === 'yes') {
 		if (md.verbose.solution) {
@@ -94,28 +120,30 @@
 		ismodelselfconsistent(md);
 	}
-
+	
 	// If we are restarting, actually use the provided runtime name:
 	restart = options.getfieldvalue('restart', '');
 
 	// First, build a runtime name that is unique
-	if (restart === 1 ) {
+	if (restart === 1) {
 		// Leave the runtimename as is
 	} else {
-		if (!(restart === '')) {
-			md.priv.runtimename=restart;
-		} else if (options.getfieldvalue('runtimename',true)) {
-			let c = new Date().getTime();
-			md.priv.runtimename = sprintf('%s-%g', md.miscellaneous.name, c);
+		if (restart !== '') {
+			md.priv.runtimename = restart;
 		} else {
-			md.priv.runtimename = md.miscellaneous.name;
-		}
-	}
-
-	// If running qmu analysis, some preprocessing of dakota files using models fields needs to be carried out
+			if (options.getfieldvalue('runtimename', true)) {
+				let c = new Date().getTime();
+				md.priv.runtimename = sprintf('%s-%g', md.miscellaneous.name, c);
+			} else {
+				md.priv.runtimename = md.miscellaneous.name;
+			}
+		}
+	}
+
+	// If running QMU analysis, some preprocessing of Dakota files using model fields needs to be carried out
 	if (md.qmu.isdakota) {
-		throw Error("solve error message: qmu runs not supported yet!");
-		//md.preqmu(options);
-	}
-
+		throw new Error("QMU not supported yet!");
+		//md = preqmu(md, options);
+	}
+	
 	// Do we load results only?
 	if (options.getfieldvalue('loadonly', false)){
@@ -124,97 +152,53 @@
 	}
 
-	// Marshall into a binary array (fid) all the fields of model
-	let fid = marshall(md); // bin file
-	
-	//deal with toolkits options: 
-	toolkitsstring = md.toolkits.ToolkitsFile(md.miscellaneous.name + '.toolkits'); // toolkits file
-
-
 	/*
-		Set success callback function
-		
-		Default: do nothing if no success callback function requested
+	Write all input arrays (as opposed to, under MATLAB/Python, input binary 
+	files)
+	
+	NOTE: The JavaScript implementation diverges significantly from the 
+		  MATLAB/Python APIs here.
 	*/
-	//{{{
-	function successCallbackDefault() {
-		solving = false;
-	}; 
-	
-	let successCallback = options.getfieldvalue('successCallback', successCallbackDefault);
-	//}}}
-	
-	
-	/*
-		Set error callback function
-		
-		Default: do nothing if no error callback function requested
-	*/
-	//{{{ 
-	function errorCallbackDefault() {
-		solving = false;
-	}; 
-	
-	let errorCallback = options.getfieldvalue('errorCallback', errorCallbackDefault);
-	//}}}
-	
-	
-	/*
-		Set solve button ID
-		
-		Default: update #solve-button element with progress updates
-	*/
-	//{{{
-	let solveButtonId = options.getfieldvalue('solveButtonId', '#solve-button');
-	//}}}
-	
-	
-	/*
-		Set Callout
-	*/
-	//{{{
-	var callout = {};
-	
-	// Default: Callout is an empty object
-	callout = options.getfieldvalue('callout', {});
-	//}}}
-	
-	
-	/*
-		Set progress bar display boolean
-		
-		Default: no progress bar
-		
-		NOTE: must have supplied a callout for progress bar to display
-	*/
-	//{{{
-	let withProgressBar = options.getfieldvalue('withProgressBar', false);
-	//}}}
-
+	let fid = null; // bin file equivalent
+	//TODO: FIND A BETTER WAY TO DO THIS! (IE, SYNC UP WRITEDATA AND HAVE A FULL DEMARSHALL/READMODEL IN PYTHON
+	if (solutionstring === 'GmshSolution') {
+		//open file for binary writing
+		fid = new fileptr('mode','w');
+	} else if (solutionstring === 'GmtSolution') {
+		//open file for binary writing
+		fid = new fileptr('mode','w');
+		let prefix='md.mesh';
+		WriteData(fid,prefix,'object',md.mesh,'fieldname','lat','format','DoubleMat','mattype',1);
+		WriteData(fid,prefix,'object',md.mesh,'fieldname','long','format','DoubleMat','mattype',1);
+	} else {
+		// Marshall into a binary array (fid) all the fields of model
+		fid = marshall(md); // bin file
+	}
+	let toolkitsstring = md.toolkits.ToolkitsFile(md.miscellaneous.name + '.toolkits'); // toolkits file equivalent
 
 	if (cluster.classname() === 'local') {//{{{
 
-		// We are running locally on the machine, using the issm module
+		// We are running locally on the machine, using the ISSM module
 		console.log('running issm locally');
 		
-		// Call issm
+		// Call ISSM
 		let outputs = issm(fid, toolkitsstring, solutionstring, md.miscellaneous.name); 
 		
-		// Recover output arguments:
+		// Recover output
 		let outputbuffer 		= outputs[0]; 
 		let outputbuffersize 	= outputs[1];
 			
 		// Load results 
-		md = loadresultsfrombuffer(md, outputbuffer, outputbuffersize); 
-		
-		// Call success callback 
-		successCallback();
-
-		return md;
+		md = loadresultsfrombuffer(md, outputbuffer, outputbuffersize); // TODO: Pass reporting construct to loadresultsfrombuffer
+		
+		// Call success callback
+		if (vesl.helpers.isFunction(vesl.ui.reporting.success_callback)) {
+			vesl.ui.reporting.success_callback();
+		}
 	//}}}
-	} else {//{{{
+	} else { //{{{
 		// We are running somewhere else on a computational server. Send the buffer to that server and retrieve output.
 		console.log('running issm remotely');
 		
-		cluster.UploadAndRun(
+		await cluster.uploadandrun(
 			md, 
 			fid, 
@@ -223,13 +207,23 @@
 			md.miscellaneous.name, 
 			md.priv.runtimename,
-			successCallback, 
-			errorCallback, 
-			solveButtonId, 
-			callout, 
-			withProgressBar
-		);
-
+			options
+		);/*
+.catch(function(e) {
+			if (vesl.helpers.isDefined(vesl.ui) && vesl.helpers.isDefined(vesl.ui.reporting) && vesl.helpers.isFunction(vesl.ui.reporting.error_callback)) {
+				vesl.ui.reporting.error_callback(e);
+			}
+		}).catch(function(e) {
+			// Handle unexpected errors (source: http://thecodebarbarian.com/async-await-error-handling-in-javascript.html)
+			console.log(e);
+		});
+			
+		if (vesl.helpers.isDefined(vesl.ui) && vesl.helpers.isDefined(vesl.ui.reporting) && vesl.helpers.isFunction(vesl.ui.reporting.success_callback)) {
+			vesl.ui.reporting.success_callback(md);
+		}
+*/
+		
+		// Why is md undefined at vesl.ui.reporting.success_callback(md)? See issm-refactor
+		
 		return md;
-	}//}}}
-}//}}}
-
+	} //}}}
+} //}}}
Index: issm/trunk/src/m/solve/solve.m
===================================================================
--- issm/trunk/src/m/solve/solve.m	(revision 25994)
+++ issm/trunk/src/m/solve/solve.m	(revision 26744)
@@ -8,26 +8,28 @@
 %
 %   Solution types available comprise:
-%   - 'Stressbalance'      or 'sb'
-%   - 'Masstransport'      or 'mt'
-%   - 'Thermal'            or 'th'
-%   - 'Steadystate'        or 'ss'
-%   - 'Transient'          or 'tr'
-%   - 'Balancethickness'   or 'mc'
-%   - 'Balancevelocity'    or 'bv'
-%   - 'BedSlope'           or 'bsl'
-%   - 'SurfaceSlope'       or 'ssl'
-%   - 'Hydrology'          or 'hy'
-%   - 'DamageEvolution'    or 'da'
-%   - 'Gia'                or 'gia'
-%   - 'Love'               or 'lv'
-%   - 'Esa'                or 'esa'
-%   - 'Sealevelrise'       or 'slr'
+%   - 'Stressbalance'        or 'sb'
+%   - 'Masstransport'        or 'mt'
+%   - 'Oceantransport'       or 'oceant'
+%   - 'Thermal'              or 'th'
+%   - 'Steadystate'          or 'ss'
+%   - 'Transient'            or 'tr'
+%   - 'Balancethickness'     or 'mc'
+%   - 'Balancethickness2'
+%   - 'BalancethicknessSoft' or 'mcsoft'
+%   - 'Balancevelocity'      or 'bv'
+%   - 'BedSlope'             or 'bsl'
+%   - 'SurfaceSlope'         or 'ssl'
+%   - 'Hydrology'            or 'hy'
+%   - 'DamageEvolution'      or 'da'
+%   - 'Gia'                  or 'gia'
+%   - 'Love'                 or 'lv'
+%   - 'Esa'                  or 'esa'
+%   - 'Sampling'             or 'smp'
 %
 %   Extra options:
-%   - loadonly         : does not solve. only load results
-%   - runtimename      : true or false (default is true), makes name unique
-%   - checkconsistency : 'yes' or 'no' (default is 'yes'), ensures checks on 
-%                        consistency of model
-%   - restart          : 'directory name (relative to the execution directory) 
+%   - loadonly         : do not solve, only load results
+%   - runtimename      : true or false (default is true); makes name unique
+%   - checkconsistency : 'yes' or 'no' (default is 'yes'); checks consistency of model
+%   - restart          : directory name (relative to the execution directory) 
 %                        where the restart file is located
 %
@@ -45,4 +47,6 @@
 elseif strcmpi(solutionstring,'mt') || strcmpi(solutionstring,'Masstransport')
 	solutionstring = 'MasstransportSolution';
+elseif strcmpi(solutionstring,'oceant') || strcmpi(solutionstring,'Oceantransport')
+	solutionstring = 'OceantransportSolution';
 elseif strcmpi(solutionstring,'th') || strcmpi(solutionstring,'Thermal')
 	solutionstring = 'ThermalSolution';
@@ -73,6 +77,6 @@
 elseif strcmpi(solutionstring,'esa') || strcmpi(solutionstring,'Esa')
 	solutionstring = 'EsaSolution';
-elseif strcmpi(solutionstring,'slr') || strcmpi(solutionstring,'Sealevelrise')
-	solutionstring = 'SealevelriseSolution';
+elseif strcmpi(solutionstring,'smp') || strcmpi(solutionstring,'Sampling')
+	solutionstring = 'SamplingSolution';    
 else
 	error(['solutionstring ' solutionstring ' not supported!']);
@@ -113,5 +117,5 @@
 end
 
-%if running QMU analysis, some preprocessing of Dakota files using models fields needs to be carried out. 
+%if running QMU analysis, some preprocessing of Dakota files using model fields needs to be carried out. 
 if md.qmu.isdakota,
 	md=preqmu(md,options);
@@ -169,5 +173,5 @@
 	end
 elseif md.settings.waitonlock>0,
-	%we wait for the done file
+	%wait for done file
 	done=waitonlock(md);
 	if md.verbose.solution,
